import hypermedia.video.*;
import java.awt.Rectangle;

OpenCV opencv;
int vw = 320, vh = 240;

void setup() {

    size( 960, 240 );

    opencv = new OpenCV( this );
    // aus performance gruenden muss die opencv capture verwendet werden
    opencv.capture(vw, vh);
}

void draw() {
    // grab frame from camera --------------------------------
    opencv.read();    
    
    // draw camera image on the left -------------------------
    image(opencv.image(), 0, 0);
    
    // make a duotone image -> several threshold calcualtion available
    // move mouse on x axis to adjust threshold
    float thresh = map(mouseX, 0, 255, 0, width);
    opencv.threshold(thresh); 
    
    // draw duotone image in the middle ----------------------
    image(opencv.image(), 320, 0);

   
    // draw blobs on the right -------------------------------   
    pushMatrix();
    translate(2 * vw, 0);
    
    // draw background
    noStroke();
    fill(200);
    rect(0,0, vw, vh);


    // find contours/ blobs in image -----------
    // adjust minArea, maxArea, maxBlobs, findHoles, maxVertices
    Blob[] blobs = opencv.blobs( 100, width*height/2, 100, true, OpenCV.MAX_VERTICES*4 );

    // draw blob results
    stroke(100);
    fill(255);
    for( int i=0; i<blobs.length; i++ ) {
        beginShape();
        for( int j=0; j<blobs[i].points.length; j++ ) {
            vertex( blobs[i].points[j].x, blobs[i].points[j].y );
        }
        endShape(CLOSE);
    }
    
    popMatrix();

}
